/***************************************************************************
                          arc_tgz.h  -  description
                             -------------------
    begin                : Sun Aug 20 2000
    copyright            : (C) 2000 by Morten Poulsen
    email                : sc@poulsen.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef _ARC_TGZ_
#define _ARC_TGZ_

#include "sc_file.h"
#include "fm_vfs.h"
#include "fm_defs.h"
#include "fm_window.h"
#include "sc_action.h"


/* Values used in typeflag field.  */

#define REGTYPE	 '0'  /* regular file */
#define AREGTYPE '\0'	/* regular file */
#define LNKTYPE  '1'	/* link */
#define SYMTYPE  '2'	/* reserved */
#define CHRTYPE  '3'	/* character special */
#define BLKTYPE  '4'	/* block special */
#define DIRTYPE  '5'	/* directory */
#define FIFOTYPE '6'	/* FIFO special */
#define CONTTYPE '7'	/* reserved */

#define _BLOCKSIZE 512


/* Values used in typeflag field.  */

#define REGTYPE	 '0'  /* regular file */
#define AREGTYPE '\0'	/* regular file */
#define LNKTYPE  '1'	/* link */
#define SYMTYPE  '2'	/* reserved */
#define CHRTYPE  '3'	/* character special */
#define BLKTYPE  '4'	/* block special */
#define DIRTYPE  '5'	/* directory */
#define FIFOTYPE '6'	/* FIFO special */
#define CONTTYPE '7'	/* reserved */

#define _BLOCKSIZE 512

struct tar_header
{                  	/* byte offset */
  char name[100];	  /*   0 */
  char mode[8];	    /* 100 */
  char uid[8];      /* 108 */
  char gid[8];	    /* 116 */
  char size[12];	  /* 124 */
  char mtime[12];	  /* 136 */
  char chksum[8];	  /* 148 */
  char typeflag;	  /* 156 */
  char linkname[100];	  /* 157 */
  char magic[6];	  /* 257 */
  char version[2];	  /* 263 */
  char uname[32];	  /* 265 */
  char gname[32];	  /* 297 */
  char devmajor[8];	  /* 329 */
  char devminor[8];	  /* 337 */
  char prefix[155];	  /* 345 */
                          /* 500 */
};

//I _really_ like the c language for this! Unions rules!
union tar_buffer {
  char               buffer[_BLOCKSIZE];
  struct tar_header  header;
};


int getoct(char *p,int width);


class cFileInTar : public cFile {
  public:
    cFileInTar(const sParsedDir& parsed):cFile(parsed.fullname) {
      spd=parsed;
    }
    ~cFileInTar() {
      Close();
    }
    bool Open(tOpenMode om);
    int Read(void *buf,int size);
    int Write(void *buf,int size) {
      return false;
    }
    void Close() {
      if (gzf!=NULL) scDELETE(gzf);
    }
    bool Delete() {
      return false;
    }
    
    int Size() {
      return filesize;
    }
    int Pos() {
      return (filesize-remaining);
    }
    int GetMode() {

    }
    bool SetMode(int) {

    }

  private:
    cFile* gzf;
    long remaining;
    long filesize;
    int filemode;
    sParsedDir spd;
};

bool TarScan(tDirContainer& cont, const sParsedDir& spd, bool onlydirs=false);
bool UnpackTar(const string& filename, const string& destdir, tProgFunc progress);


#endif //_ARC_TGZ_
