/***************************************************************************
                 fm_conio.h  -  handles all output to screen
                             -------------------
    begin                : Mon Jan 3 2000
    copyright            : (C) 2000 by MoP
    email                : sc@poulsen.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _FM_CONIO
#define _FM_CONIO

#include <string>
#include "unicon.h"

#undef erase //()

#define _DEFAULTBG cBLUE
#define _DEFAULTFG cLGRAY

const int _centered = -1;
const int _rightaligned = -2;

struct sBox {
 string upleft,upright,dnleft,dnright,titleleft,titleright,hline,vline,fillchar,taggedchar;
};

sBox GetBoxChars();

//Initializes screen writing
void InitConIO();

//Finishes Screen writing
void DoneConIO();

//Only relevant in Linux, refreshes screensize when in an xterm
void RefreshConIO();

//Write a message at top of screen
void WriteTopMessage(const string&);

//Write fast on screen, no centered, filling etc.
void WrFast(const char s[],int x, int y, int fg,int bg);

//Write on the screen 
void Wr(int x, int y, const string& s, int fg=_DEFAULTFG, int bg=_DEFAULTBG,int fill=0);

//Write on the screen and highlight allchars preceded by a ~ (tilde)
void WrHl(int x, int y, const string& s, int fg=/*_DEFAULTFG*/7, int bg=_DEFAULTBG,int fill=0);

//Clear the screen with _DEFAULTBG
void ClearScreen();
void ClearScreenWhite();
void ClearScreenBlack();

//Give me a horizontal line of specified length
string GetHLine(int);

void HideCursor();
void ShowCursor();

int ScreenW();
int ScreenH();

void GotoXY(int,int);

void ShowTime();

#endif //_FM_CONIO
