/***************************************************************************
                          fm_console.h  -  description
                             -------------------
    begin                : Mon Jan 3 2000
    copyright            : (C) 2000 by MoP
    email                : sc@poulsen.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef _FM_CONSOLE
#define _FM_CONSOLE

#include <string>
#include "fm_debug.h"
#include "fm_dircon.h"
#include "fm_viewcon.h"
#include "fm_editcon.h"

enum tConsoleMode {cmDir, cmView, cmEdit};

//A console which can "Contain" dir/view/edit screens
class cConsole {
  public:
    cConsole(int);
    ~cConsole();

    void Update();
    void TreatKey(tKey& k);
    void Idle();
    bool ConfirmExit();
    string GetTitle();
    string GetFullPath() {return dir->GetFullPath();};
    void SetOutDir() {dir->SetOutDir();};
  private:
    int connr;
    tConsoleMode mode;
    cDirWindow* dir;
    cViewWindow* view;
    cEditWindow* edit;

};



#endif //_FM_CONSOLE
