
/***************************************************************************
                          fm_dircon.h  -  description
                             -------------------
    begin                : Mon Jan 3 2000
    copyright            : (C) 2000 by MoP
    email                : sc@poulsen.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _FM_DIRCON
#define _FM_DIRCON

//#include "fm_console.h"
#include "fm_keyboard.h"
#include "fm_conio.h"
#include "fm_vfs.h"
#include "fm_init.h"

class cDirWindow {
  public:
    cDirWindow();
    ~cDirWindow();
    void TreatKey(tKey k);
    void Update();
    void Idle();
    string GetTitle();
    string GetCurrentFile();
    string GetFullPath() {return fullpath;};
    void SetOutDir() {_sc_outdir=fullpath;};
  private:
    tDirContainer files;
    tFilesystems filesys;
    tStringArray dirhistory;

    string titleline;
    string mask;
    string filesearch;
    string fullpath;
    string lastdir;
    int cur;
    int namelength;
    int linelength;
    int nocolumns;
    int topfile;
    int linespercolumn;
    int totalfilesonscreen;
    sBox box;
    
    void CalcFilelistInfo();
    string MakeFileString(int);
    bool Rescan();
    void Execute();
    void Write1File(int);
    void WriteHeader();
    void WriteAllFiles();
    void MoveToFile(const string& fname);
    void SearchFile();
    void TreatMoveKey(tKey k);
    void UpdateFirstShown();
    void UpdateDirHistory();

    void SetNewDir(const string&, const string& movetofile="");

    void CheckCollection();

    bool DoTagging();

    int CA(); int CM(); //Count all / marked
    long int MA(); long int MM(); //Measure all/marked
    int NOS(); //Number of "specials"
    
};

string MakeAttr(const cDirEntry& de);

#endif //_FM_DIRCON

