/***************************************************************************
       fm_editcon.h  -  An editorclass to fill into a console
                             -------------------
    begin                : Mon Jan 3 2000
    copyright            : (C) 2000 by MoP
    email                : sc@poulsen.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/



#ifndef _FM_EDITCON
#define _FM_EDITCON

#include "fm_textfile.h"
#include "fm_keyboard.h"


class cEditWindow {
public:
  cEditWindow(const string&);
  cEditWindow(); //newfile
  ~cEditWindow();
  void TreatKey(tKey);
  void Update();
  string GetTitle();
  bool ConfirmExit();
  bool Error() {return error;};
  void Idle();
  bool ChangedAtAll() {return changedatall;};
  void SetPath(const string& path) {fullpath=path;};
private:
  bool error, changedatall;
  int fromleft, topline, cx, cy,blst_x,blst_y, blend_x, blend_y;
  string filename, fullpath;
  cTextFile lines;
  bool indent;
  bool wordwrap;

  bool nowblocking;
  bool finishedreading;
  bool changed;

  bool Find();
  bool FindAgain();

  void WriteLine(long int);
  void WriteCurrentLine(bool);
  void WriteHeader();

  void InsertChar(char);
  void InsertReturn(); //no returnvalue as screen should always be updated
  bool DoDelete();
  bool DoBackSpace();
  void DoCopy(bool=false);
  bool DoCut();
  bool DoPaste();
  void CutLine();
  void PasteLine();

  void HandleSelection();
  void UpdateCursor();
  
  bool SaveFile();
  char CC(); //Current char
};

bool DedicatedEdit(const string& filename="", bool forceexternal=false);

#endif //_FM_EDITCON
