/***************************************************************************
                   fm_sort.cpp  -  handles the sorting of files
                             -------------------
    begin                : Mon Jan 3 2000
    copyright            : (C) 2000 by MoP
    email                : sc@poulsen.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <string.h>
#include "fm_sort.h"
#include "fm_debug.h"


void QSort(tDirContainer& f,int start, int end) {
  //cDirEntry pivot=f[start]; //Pick first element
  cDirEntry pivot=f[((end-start)/2)+start]; //Pick middle element,
                                            //Speeded up thing quit a bit...
  
  int i=start;
  int j=end;
  do {
    while (f[i]<pivot) {
      i++;
    }
    while (pivot<f[j]) {
      j--;
    }
    if (i<=j) {
      f.Swap(i,j);
      i++; j--;
    }
  } while (i<=j);
  if (start<j) QSort(f,start,j);
  if (i<end) QSort(f,i,end);
}

void SortFiles(tDirContainer& f) {
  if (f.Size()==0) {
    Dbg("fm_sort: no files to sort");
  } else {
    Dbg("fm_sort: starting sort");
    QSort(f,0,f.Size()-1);
  }
}
