/***************************************************************************
                          fm_str.h  -  string functions
                             -------------------
    begin                : Thu Dec 23 1999
    copyright            : (C) 1999 by MoP
    email                : sc@poulsen.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


/***************************************************************************/

#ifndef _FM_STR
#define _FM_STR

#include <string>
#include "array.h"
#define _SPACES "                                                                                                                                                                                      "

typedef cArray<string> tStringArray;

string LeadingSpace(const string& s, int len);
string Leading0(const string& s, int len);

string Copy(const string& s, int start, int count=9999);
string GetSpaces(int len);

string LCopy(const string&, int, char=' ');
string RCopy(const string&, int, char=' ');

string LTrim(const string&, int);
string RTrim(const string&, int);

string GetPartExt(const string&, bool handletar=true);
string GetPartName(const string&);
string GetPartDir(const string&);

string AddSlash(const string&);
string StripSlash(const string&);

string StrReplace(const string&, const string&, const string&);

int CountChar(const string&, char, bool=false);

bool StripChar(string&, char, char='\0', char='\0');
string Upcase(const string&);
char Upcase(char);

//Different string compare routines
bool Equal(const string&, const string&); //Case IN-sensitive
bool WildcardMatch(const string&, const string&);
bool MatchStart(const string&, const string&);
bool MatchEnd(const string&, const string&);

string MkStr(int,bool=false);
string MkStr(long int,bool=false);
string MkStr(unsigned long int,bool=false);
string MkStr(double);
//string MkStr(long long int,bool=false);
string MkStr(bool);
string MkStr(char);
string MkStr(char*);

string MkHex(unsigned char c);
string MkHex(unsigned int i);

string GetPercent(long int part, long int total);

string GetRotator();


string StripSurroundSpace(const string&);
string FixStr(const string&, int);

//Splits a string int substring seperated by a given char, putting the resulting
//strings into a stringarray
//return true if number of found substring equals the expected number
bool SplitString(const string&,tStringArray&,char,int=0,bool=false);





#endif //_FM_STR
