#ifndef _FM_TEXTFILE
#define _FM_TEXTFILE

#include <string>
#include "array.h"
#include "sc_file.h"
//#include "sc_binfile.h"

enum tTextMode {tmNormal, tmHex};
enum tTextFileFlavor {DOS, Unix, Mac, Binary, Unset};

typedef cArray<string> tStringArray;

class cTextFile {
  public:
    cTextFile() {flavor=Unset; sampletaken=false; tabspresent=false;};
    ~cTextFile();

    bool ReadWholeFile(const string&, tTextMode=tmNormal);
    bool StartReadFromFile(const string&, tTextMode=tmNormal);
    bool ContinueRead();
    bool WriteToFile(const string&);

    long FindString(const string&,long=0);
    
    string& operator [] (long int);
    void operator += (const string& s) {lines+=s;};
    void operator -= (long int i) {lines-=i;};
    void operator = (const tStringArray& other) {lines=other;};

    void Remove(long int index);
    void Insert(const string& s, long int index) {lines.Insert(s,index);};
    long int Size() {return lines.Size();};
    tTextFileFlavor GetFlavor() {return flavor;};
    void SetFlavor(tTextFileFlavor f) {flavor=f;};
    bool TabsPresent() {return tabspresent;};

    int GetPercentRead();
  private:
    cFile *f;
    tStringArray lines;
    tTextMode mode;
    bool sampletaken;
    bool usegz;
    bool tabspresent;
    //string name;
    tTextFileFlavor flavor;

    bool ReadAsNormal();
    bool ReadAsHex(int transfsize=0, unsigned char transferred[]=NULL);

//    void CheckForHex();
};

//bool ReadTextFile(const string&, tStringArray&, bool=false);

#endif //_FM_TEXTFILE
