/***************************************************************************
                inifile.h  -  Handling of INI-style textfiles
                             -------------------
    begin                : Mon Jan 3 2000
    copyright            : (C) 2000 by MoP
    email                : sc@poulsen.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

//Version 0.0.3

#ifndef _INIFILE_H
#define _INIFILE_H

#include <string>
#include "array.h"

const int faRead=0;
const int faWrite=1;

class cINIFile {
  public:
    cINIFile(string, int=0);
    cINIFile(char *, int=0);
    ~cINIFile();
    bool Error() {return error;};
    bool Flush();
    int GetValue(const string&, int);
    bool GetValue(const string&, bool);
    string GetValue(const string&, const string&);
    string GetValue(const string&, const char*);
    
    void SetValue(const string&, int);
    void SetValue(const string&, bool);

    void SetValueEncrypted(const string&, const string&, bool=false);
    void SetValue(const string&, const string&, bool=false);
    void SetComment(const string& comment="");
    void SetBlank();

    void SetEncryptKey(char key) {encrypt_key=key;};
  private:
    cArray<string> lines;
    cArray<bool> touched;

    char encrypt_key;

    bool error;
    int mode;
    string name;
    void ReadLines();
    void WriteLines();
    string FindValue(const string&);

    
};


#endif //_INIFILE_H
