/***************************************************************************
                          mstring.h  -  description
                             -------------------
    begin                : Thu Aug 17 2000
    copyright            : (C) 2000 by Morten Poulsen
    email                : sc@poulsen.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _MSTRING_H_
#define _MSTRING_H_

#include <stdio.h>
#include <string>

class mstring {
  public:
    mstring() {s="";};
    mstring(const mstring& other) {
      s=other.stl_str();
    };
    mstring(const string& other) {
      s=other;
    };
    mstring(const char& other) {
      s=other;
    };
    mstring(long int li) {
      s=_mkstr(li);
    };
    ~mstring();

    string upcase(const mstring& other) const {
      return _upcase(other.stl_str());
    }

    string upcase(const string& other) const {
      return _upcase(other);
    }

    string upcase() {
      s=_upcase(s);
      return s;
    }    

    string stl_str() const {return s;};
    int length() const {return s.length();};
  private:
    string _upcase(const string& _s) const {
      string temp=_s;
      for(int i=0; i<s.length(); i++) {
        temp[i]=toupper(_s[i]);
      }
      return temp;
    }

    string _mkstr(long int i) {
      char c[32];
      sprintf(c,"%u",i);
      string temp=c;
      return temp;
    }
  
    string s;    
};

#endif //_MSTRING_H_
