/***************************************************************************
                          sc_archive.h  -  description
                             -------------------
    begin                : Mon Mar 20 2000
    copyright            : (C) 2000 by Morten Poulsen
    email                : sc@poulsen.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef _SC_ARCHIVE
#define _SC_ARCHIVE

#include <string>
#include <time.h>
#include "target.h"
#include "fm_vfs.h"
//#include "sc_archive.h"
#include "sc_file.h"
#include "sc_action.h"

//const int _noarc_extensions=10;
const string _arc_extensions[]={".ZIP",//"7.ZIP",
                                                 ".TAR.GZ",//".TAR.GZ",
                                                 #ifdef _BZ2_SUPPORT_
                                                   ".TAR.BZ2",//".TAR.BZ2",
                                                 #endif
                                                 ".TGZ",//".TGZ",
                                                 ".TAR",//".TAR"
                                                 ""};




cFile* GetArcFilePointer(const sParsedDir&);
bool ArchiveScan(tDirContainer&, const string& dir, bool=false);
bool UnpackWholeFile(const string& filename, const string& destdir, tProgFunc progress);
bool ArcDoesDirExist(const string&);
bool ArcDoesFileExist(const string&);
bool ArcDeleteFile(const string& name);

//Utilities for arc_*-files
void Add2Dots(tDirContainer& cont);
//time_t MakeTimeFromUZT(const tm_unz& t);
bool FixDirsInArchive(string& name, const sParsedDir& spd);
void CheckForMissingDirRecord(tDirContainer& cont, const string& fullname, const sParsedDir& spd, tModeAttr modeattr);


#endif //_SC_ARCHIVE
