#include <string.h>
#include "sc_syntax.h"
#include "syntax_cpp.h"
#include "syntax_pascal.h"
#include "syntax_defs.h"
#include "fm_str.h"
#include "fm_conio.h"

bool CanDoSyntaxByName(const string& name) {
  string ext=GetPartExt(name);
  if (ext==".CPP" || ext==".H" || ext==".C" || ext==".HPP" || ext==".CC") return true;
  if (ext==".PAS") return true;

  return false;
}

bool CanDoSyntaxByFirstLine(const string& line) {

  return false;
}

bool DoSyntaxHighlighting(const string& name, cTextFile& lines) {
  string ext=GetPartExt(name);
  if (ext==".CPP" || ext==".H" || ext==".C" || ext==".HPP" || ext==".CC") return DoCPPSyntax(lines);
  if (ext==".PAS") return DoPascalSyntax(lines);
  return false;
}

void WrSyntax(int y, const string& s, int fromleft=0, int fill=0) {
  char buf[999];
  if (fromleft>s.length()) {
    Wr(1,y,"",cBLACK,cWHITE,ScreenW()); //empty line, just fill out
    return;
  }
  strcpy(buf, s.substr(fromleft,ScreenW()).c_str());
  char delimeter[2]; delimeter[0]=_col; delimeter[1]=0x00;
  char *part;
  part=strtok(buf,delimeter);

  if (part==NULL) { //No delimeters==no colors
    string ts=buf;
    Wr(1,y,ts,cBLACK,cWHITE,ScreenW()); //empty line, just fill out
    return;
  }
  int x=1;  

  //Determine color of first part
  int color;
  if (fromleft>0) {
    for(int i=fromleft; i>0; i--) {
      if (s[i]==_col) {
        color=int(s[i+1])-1;
        break;
      }
    }
    color=COL_DEFAULT; //should not be possible as all lines should start with color;
  }
  /*else {
    if (part[0]<0x20) {
      color=int(part[0])-1;
    }
  }*/
  while (part!=NULL) {
    color=int(part[0])-1; //Not first part
    WrFast(&part[1],x,y,color,cWHITE);
    x+=(strlen(part)-1);
    part=strtok(NULL,delimeter);
  }
  if (x<ScreenW()) {
    //fill out gap at end
    Wr(x,y,"",cBLACK,cWHITE,ScreenW()-x+1);
  }

}
