/***************************************************************************
                          target.h  -  description
                             -------------------
    begin                : Mon Jan 3 2000
    copyright            : (C) 2000 by MoP
    email                : fmpro@poulsen.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _TARGET_H_
#define _TARGET_H_

//Just for backup, so I can go back to the old system
#define _NEW_TARGET_SYSTEM_

#ifdef _NEW_TARGET_SYSTEM_
  #define _TARGET_UNKNOWN_
  #undef _TARGET_DESCRIPTION_
  #undef _SYMLINKS_EXIST_
  #undef _FTP_POSSIBLE_
  #undef _TARGETFS_STAT_
  #undef _TARGETFS_FINDFIRST_
  #undef _TARGETFS_SLASH_
  #undef _TARGETFLAVOR_DOS_
  #undef _TARGETFLAVOR_UNIX_
  #undef _TARGET_TEXTIO_CURSES_
  #undef _TARGET_TEXTIO_CONIO_
  #undef _TARGET_WIN32_
  #undef _RPM_SUPPORT_
  #undef _BZ2_SUPPORT_
  #undef _SOCKET_SUPPORT_
  #undef _NO_STATFS_

  #ifdef _TARGET_UNKNOWN_
    #if defined(DJGPP)
      #define _TARGET_DESCRIPTION_ "DOS 32bit DJGPP"
      #define _TARGETFS_SLASH_ "\\"
      #define _TARGETFLAVOR_DOS_
      #define _TARGET_TEXTIO_CONIO_
      #define _TARGET_DJGPP_
      #define _TARGETFS_FINDFIRST_
      #undef _TARGET_UNKNOWN_
    #endif
  #endif

  #ifdef _TARGET_UNKNOWN_
    #if defined(__linux__) || defined(__Linux__)
      #define _TARGET_DESCRIPTION_    "Unix/Linux"
      #define _TARGET_LINUX_
      #define _SYMLINKS_EXIST_
      #define _FTP_POSSIBLE_
      #define _TARGETFS_SLASH_ "/"
      #define _TARGETFLAVOR_UNIX_
      #define _TARGET_TEXTIO_CURSES_
      #define _TARGETFS_STAT_
      #define _BZ2_SUPPORT_
      #define _SOCKET_SUPPORT_
      #undef _TARGET_UNKNOWN_
    #endif
  #endif

  #ifdef _TARGET_UNKNOWN_
    #if defined(__FreeBSD__)
      #define _TARGET_DESCRIPTION_    "Unix/FreeBSD"
      #define _TARGET_FREEBSD_
      #define _SYMLINKS_EXIST_
      #define _FTP_POSSIBLE_
      #define _TARGETFS_SLASH_ "/"
      #define _TARGETFLAVOR_UNIX_
      #define _TARGET_TEXTIO_CURSES_
      #define _TARGETFS_STAT_
      #undef _TARGET_UNKNOWN_
    #endif
  #endif

  #ifdef _TARGET_UNKNOWN_
    #if defined(__NetBSD__)
      #define _TARGET_DESCRIPTION_    "Unix/NetBSD"
      #define _TARGET_NETBSD_
      #define _SYMLINKS_EXIST_
      #define _FTP_POSSIBLE_
      #define _TARGETFS_SLASH_ "/"
      #define _TARGETFLAVOR_UNIX_
      #define _TARGET_TEXTIO_CURSES_
      #define _TARGETFS_STAT_
      #undef _TARGET_UNKNOWN_
    #endif
  #endif

  #ifdef _TARGET_UNKNOWN_
    #if defined(__CYGWIN__)
      #define _TARGET_DESCRIPTION_    "Win32/Cygnus"
      #define _TARGET_CYGWIN_
      #define _TARGET_WIN32_
      //#define _FTP_POSSIBLE_
      #define _TARGETFS_SLASH_ "\\"
      #define _TARGETFLAVOR_DOS_
      #define _TARGET_TEXTIO_CURSES_
      #define _TARGETFS_STAT_
      #undef _TARGET_UNKNOWN_
    #endif
  #endif

  #ifdef __TARGET_UNKNOWN_
    #ifdef __MING32__
//    #include <_mingw.h>
//    #if defined(__MINGW_VERSION)
      #define _TARGET_DESCRIPTION_    "Win32/Mingw"
      #define _TARGET_MINGW_
      #define _TARGET_WIN32_
      //#define _FTP_POSSIBLE_
      #define _TARGETFS_SLASH_ "\\"
      #define _TARGETFLAVOR_DOS_
      //#define _TARGET_TEXTIO_CONIO_
      #define _TARGET_TEXTIO_CURSES_
      #define _TARGETFS_FINDFIRST_
      //#define _NO_STATFS_
      #undef _TARGET_UNKNOWN_
    #endif
  #endif

  #ifdef _TARGET_UNKNOWN_
//    #include <_mingw.h>
//    #if defined(__MINGW_VERSION)
      #define _TARGET_DESCRIPTION_    "Win32/Mingw/default"
      #define _TARGET_MINGW_
      #define _TARGET_WIN32_
      //#define _FTP_POSSIBLE_
      #define _TARGETFS_SLASH_ "\\"
      #define _TARGETFLAVOR_DOS_
      #define _TARGET_TEXTIO_CONIO_
      //#define _TARGET_TEXTIO_CURSES_
      #define _TARGETFS_FINDFIRST_
      //#define _NO_STATFS_
      #undef _TARGET_UNKNOWN_
//    #endif
  #endif

  #ifdef _TARGET_UNKNOW_
    #error "Hey, I don't know you target!"
  #endif

#else //_NEW_TARGET_SYSTEM_


#define _TARGET_UNKNOWN_
#undef _SYMLINKS_EXIST_
#undef _FTP_POSSIBLE_

// ######################################### define target OS

#ifdef _TARGET_UNKNOWN_
  #if defined(DJGPP)
  #define _TARGET_GO32_
  #define _TARGET_DJGPP_
  #define _TARGET_DESCRIPTION_    "DOS/DJGPP"
  #undef _TARGET_UNKNOWN_
  #endif
#endif

#ifdef _TARGET_UNKNOWN_
  #if defined(__linux__) || defined(__Linux__)
  #define _TARGET_LINUX_
  #define _TARGET_DESCRIPTION_    "UNIX/LINUX"
  #undef _TARGET_UNKNOWN_
  #endif
#endif

#ifdef _TARGET_UNKNOWN_
  #if defined(__NetBSD__) 
  #define _TARGET_NETBSD_
  #define _TARGET_DESCRIPTION_    "UNIX/NETBSD"

  #undef _TARGET_UNKNOWN_
  #endif
#endif

#ifdef _TARGET_UNKNOWN_
  #if defined(__FreeBSD__)
  #define _TARGET_NETBSD_
  #define _TARGET_DESCRIPTION_    "UNIX/FREEBSD"
  #undef _TARGET_UNKNOWN_
  #endif
#endif



/*#ifndef _TARGET_DESCRIPTION_
  #define _TARGET_DESCRIPTION_    "UNKNOWN/UNKNOWN"
#endif*/

// ######################################### define target DOS platforms

#if defined(_TARGET_DJGPP_)
  #define _TARGET_DOS_
  #undef _TARGET_UNKNOWN_
#endif

// ######################################### define target UNIX platforms

#if defined(_TARGET_LINUX_) || defined(_TARGET_NETBSD_)
  #define _TARGET_UNIX_
  #define _SYMLINKS_EXIST_
  #undef _TARGET_UNKNOWN_
  #define _FTP_POSSIBLE_
#endif



#ifdef _TARGET_UNKNOWN_
/*  #error "Unknown target please define one manually!"
  #error "Supported are _TARGET_LINUX_, _TARGET_DJGPP_"
  #error "Read README or COMPILE file(s) for details"*/
  #define _TARGET_DOS_
  #define _TARGET_WIN32_
  #define _TARGET_MINGW32_
  #define _TARGET_DESCRIPTION_   "Win32/MingW32"
  #undef _TARGET_UNKNOWN_

#endif


#endif //_NEW_TARGET_SYSTEM_

#endif //_TARGET_H_
